
void LoadLibs(){
  //Cintex laden
  gSystem->Load("libCintex.so");
  //enable Cintex
  ROOT::Cintex::Enable();

  //HepMC laden
  gSystem->Load("libHepMC.so");
  //Reflex dictionary fuer HepMC laden
  gSystem->Load("~/projects/HepMCReflex/libHepMCDict.so");
  //Lib (incl. dictionary?) fuer HepMCVisualElements laden
  gSystem->Load("libHepMCVisual.so");
}

void TestNoReflex(){

  LoadLibs();
  
  using namespace HepMC;
  //Draw a new BrowserFrame
  //VisualBrowserFrame * vbrowser = new VisualBrowserFrame();
  TCanvas * c1 = new TCanvas();
  
  //Two particles in a row
  VisualVertex   * v0 = new VisualVertex(.05,.1);
  VisualVertex   * v1 = new VisualVertex(.24,.1);
  VisualVertex   * v2 = new VisualVertex(.45,.1);
  VisualParticle * p1 = new VisualParticle(0,1);
  VisualParticle * p2 = new VisualParticle(0,2);
  v0->add_particle_out(p1);
  v1->add_particle_in(p1); v1->add_particle_out(p2);
  v2->add_particle_in(p2);
  p1->SetShow(); p2->SetShow();
  v1->Draw();
}

void TestCLHEP(){

  //Cintex laden
  gSystem->Load("libCintex.so");
  //enable Cintex
  ROOT::Cintex::Enable();

  //HepMC laden
  gSystem->Load("/home/sboeser/atlas/athena/12.0.6/sw/lcg/external/clhep/1.9.2.2/slc3_ia32_gcc323/lib/libCLHEP-HepMC-1.9.2.2.so");
 // gSystem->Load("/home/sboeser/atlas/athena/12.0.6/sw/lcg/external/clhep/1.9.2.2/slc3_ia32_gcc323/lib/libHepMC.so");
//  gSystem->Load("/home/sboeser/atlas/athena/12.0.6/sw/lcg/app/releases/RELAX/RELAX_1_1_0/slc3_ia32_gcc323/lib/libHepMCRflx.so");
 // gSystem->Load("/home/sboeser/atlas/athena/12.0.6/sw/lcg/external/clhep/1.9.2.2/slc3_ia32_gcc323/lib/libCLHEP-Vector-1.9.2.2.so");
  //Lib (incl. dictionary?) fuer HepMCVisualElements laden
//  gSystem->Load("libHepMCVisual.so");

  using namespace HepMC;
  //Draw a new BrowserFrame
  //VisualBrowserFrame * vbrowser = new VisualBrowserFrame();
  TCanvas * c1 = new TCanvas();
  
  //Six examples
  
  HepLorentzVector fv(0,0,0,0);
 
  //Two particles in a row
  VisualVertex   * v0 = new VisualVertex(.05,.1);
  VisualVertex   * v1 = new VisualVertex(.24,.1);
  VisualVertex   * v2 = new VisualVertex(.45,.1);
  VisualParticle * p1 = new VisualParticle(fv,1);
  VisualParticle * p2 = new VisualParticle(fv,2);
  v0->add_particle_out(p1);
  v1->add_particle_in(p1); v1->add_particle_out(p2);
  v2->add_particle_in(p2);
  p1->SetShow(); p2->SetShow();
  v1->Draw();

  //Branching in the end
  VisualVertex   * v3 = new VisualVertex(.05,.4);
  VisualVertex   * v4 = new VisualVertex(.24,.4);
  VisualVertex   * v5 = new VisualVertex(.45,.3);
  VisualVertex   * v6 = new VisualVertex(.45,.5);
  VisualParticle * p3 = new VisualParticle(fv,3);
  VisualParticle * p4 = new VisualParticle(fv,6);
  VisualParticle * p5 = new VisualParticle(fv,7);
  v3->add_particle_out(p3);
  v4->add_particle_in(p3); v4->add_particle_out(p4); v4->add_particle_out(p5);
  v5->add_particle_in(p4);
  v6->add_particle_in(p5);
  p3->SetShow(); p4->SetShow(); p5->SetShow();
  v3->Draw();
  
  //Branching in the beginning
  VisualVertex   * v7 = new VisualVertex(.05,.6);
  VisualVertex   * v8 = new VisualVertex(.05,.8);
  VisualVertex   * v9 = new VisualVertex(.24,.7);
  VisualVertex   * v10 = new VisualVertex(.45,.7);
  VisualParticle * p6 = new VisualParticle(fv,6);
  VisualParticle * p7 = new VisualParticle(fv,7);
  VisualParticle * p8 = new VisualParticle(fv,8);
  v7->add_particle_out(p6);
  v8->add_particle_out(p7);
  v9->add_particle_in(p6); v9->add_particle_in(p7); v9->add_particle_out(p8);
  v10->add_particle_in(p8);
  p6->SetShow(); p7->SetShow(); p8->SetShow();
  v10->Draw();

  //A loop
  VisualVertex   * v11 = new VisualVertex(.55,.2);
  VisualVertex   * v12 = new VisualVertex(.65,.2);
  VisualVertex   * v13 = new VisualVertex(.75,.1);
  VisualVertex   * v14 = new VisualVertex(.7,.3);
  VisualVertex   * v15 = new VisualVertex(.85,.2);
  VisualVertex   * v16 = new VisualVertex(.95,.2);
  VisualVertex   * v17 = new VisualVertex(.8,.3);
  VisualParticle * p11 = new VisualParticle(fv,11);
  VisualParticle * p12 = new VisualParticle(fv,12);
  VisualParticle * p13 = new VisualParticle(fv,13);
  VisualParticle * p14 = new VisualParticle(fv,14);
  VisualParticle * p15 = new VisualParticle(fv,15);
  VisualParticle * p16 = new VisualParticle(fv,16);
  VisualParticle * p17 = new VisualParticle(fv,17);
  VisualParticle * p18 = new VisualParticle(fv,18);
  v11->add_particle_out(p11);
  v12->add_particle_in(p11);
    v12->add_particle_out(p12);
    v12->add_particle_out(p13);
  v13->add_particle_in(p12); v13->add_particle_out(p14);
  v14->add_particle_in(p13); v14->add_particle_out(p15);
  v17->add_particle_in(p15); v17->add_particle_out(p17);
  v15->add_particle_in(p14); v15->add_particle_in(p17);
  v12->add_particle_out(p18); v15->add_particle_in(p18);
    v15->add_particle_out(p16);
  v16->add_particle_in(p16);
  p11->SetShow(); p12->SetShow(); p13->SetShow();
  p14->SetShow(); p15->SetShow(); p16->SetShow();
  p17->SetShow(); p18->SetShow();

  //Add these events to an event
  VisualEvent* evt = new VisualEvent();
  evt->add_vertex(v11);
  evt->add_vertex(v12);
  evt->add_vertex(v13);
  evt->add_vertex(v14);
  evt->add_vertex(v15);
  evt->add_vertex(v16);
  evt->add_vertex(v17);
  evt->set_signal_process_vertex(v11);
  evt->print();
  evt->SetPDT(pdt);
  evt->Draw();
  
  
  //One loose end
  VisualVertex   * v23 = new VisualVertex(.55,.5);
  VisualVertex   * v24 = new VisualVertex(.75,.5);
  VisualVertex   * v25 = new VisualVertex(.95,.4);
  VisualParticle * p23 = new VisualParticle(fv,23);
  VisualParticle * p24 = new VisualParticle(fv,24);
  VisualParticle * p25 = new VisualParticle(fv,25);
  v23->add_particle_out(p23);
  v24->add_particle_in(p23); v24->add_particle_out(p24);
  v24->add_particle_out(p25);
  v25->add_particle_in(p24);
  p23->SetShow(); p24->SetShow(); p25->SetShow();
  v23->Draw();
  
  //Branching in the beginning
  VisualVertex   * v38 = new VisualVertex(.55,.8);
  VisualVertex   * v39 = new VisualVertex(.75,.7);
  VisualVertex   * v40 = new VisualVertex(.95,.7);
  VisualParticle * p36 = new VisualParticle(fv,36);
  VisualParticle * p37 = new VisualParticle(fv,37);
  VisualParticle * p38 = new VisualParticle(fv,38);
  VisualParticle * p39 = new VisualParticle(fv,39);
  VisualParticle * p40 = new VisualParticle(fv,21);
  VisualParticle * p41 = new VisualParticle(fv,22);
  v38->add_particle_out(p37);
  v39->add_particle_in(p37); v39->add_particle_in(p36); v39->add_particle_out(p38);
  v40->add_particle_in(p38);
  v39->add_particle_in(p39);
  v39->add_particle_in(p40);
  v39->add_particle_in(p41);
  p36->SetShow(); p37->SetShow(); p38->SetShow();
  v39->Draw();
}

void TestVisual(){

  LoadLibs();
  
  using namespace HepMC;
  //Draw a new BrowserFrame
  //VisualBrowserFrame * vbrowser = new VisualBrowserFrame();
  TCanvas * c1 = new TCanvas();
  
  //Get a pdt
  IO_PDG_ParticleDataTable iopdt("PDG_table_2006.mc");
  ParticleDataTable* pdt = iopdt.read_particle_data_table();
  pdt->make_antiparticles_from_particles();
  pdt->print();

  //Six examples
  
  HepMC::FourVector fv(0,0,0,0);
 
  //Two particles in a row
  VisualVertex   * v0 = new VisualVertex(.05,.1);
  VisualVertex   * v1 = new VisualVertex(.24,.1);
  VisualVertex   * v2 = new VisualVertex(.45,.1);
  VisualParticle * p1 = new VisualParticle(fv,1);
  VisualParticle * p2 = new VisualParticle(fv,2);
  v0->add_particle_out(p1);
  v1->add_particle_in(p1); v1->add_particle_out(p2);
  v2->add_particle_in(p2);
  p1->SetShow(); p2->SetShow();
  v1->Draw();

  //Branching in the end
  VisualVertex   * v3 = new VisualVertex(.05,.4);
  VisualVertex   * v4 = new VisualVertex(.24,.4);
  VisualVertex   * v5 = new VisualVertex(.45,.3);
  VisualVertex   * v6 = new VisualVertex(.45,.5);
  VisualParticle * p3 = new VisualParticle(fv,3);
  VisualParticle * p4 = new VisualParticle(fv,6);
  VisualParticle * p5 = new VisualParticle(fv,7);
  v3->add_particle_out(p3);
  v4->add_particle_in(p3); v4->add_particle_out(p4); v4->add_particle_out(p5);
  v5->add_particle_in(p4);
  v6->add_particle_in(p5);
  p3->SetShow(); p4->SetShow(); p5->SetShow();
  v3->Draw();
  
  //Branching in the beginning
  VisualVertex   * v7 = new VisualVertex(.05,.6);
  VisualVertex   * v8 = new VisualVertex(.05,.8);
  VisualVertex   * v9 = new VisualVertex(.24,.7);
  VisualVertex   * v10 = new VisualVertex(.45,.7);
  VisualParticle * p6 = new VisualParticle(fv,6);
  VisualParticle * p7 = new VisualParticle(fv,7);
  VisualParticle * p8 = new VisualParticle(fv,8);
  v7->add_particle_out(p6);
  v8->add_particle_out(p7);
  v9->add_particle_in(p6); v9->add_particle_in(p7); v9->add_particle_out(p8);
  v10->add_particle_in(p8);
  p6->SetShow(); p7->SetShow(); p8->SetShow();
  v10->Draw();

  //A loop
  VisualVertex   * v11 = new VisualVertex(.55,.2);
  VisualVertex   * v12 = new VisualVertex(.65,.2);
  VisualVertex   * v13 = new VisualVertex(.75,.1);
  VisualVertex   * v14 = new VisualVertex(.7,.3);
  VisualVertex   * v15 = new VisualVertex(.85,.2);
  VisualVertex   * v16 = new VisualVertex(.95,.2);
  VisualVertex   * v17 = new VisualVertex(.8,.3);
  VisualParticle * p11 = new VisualParticle(fv,11);
  VisualParticle * p12 = new VisualParticle(fv,12);
  VisualParticle * p13 = new VisualParticle(fv,13);
  VisualParticle * p14 = new VisualParticle(fv,14);
  VisualParticle * p15 = new VisualParticle(fv,15);
  VisualParticle * p16 = new VisualParticle(fv,16);
  VisualParticle * p17 = new VisualParticle(fv,17);
  VisualParticle * p18 = new VisualParticle(fv,18);
  v11->add_particle_out(p11);
  v12->add_particle_in(p11);
    v12->add_particle_out(p12);
    v12->add_particle_out(p13);
  v13->add_particle_in(p12); v13->add_particle_out(p14);
  v14->add_particle_in(p13); v14->add_particle_out(p15);
  v17->add_particle_in(p15); v17->add_particle_out(p17);
  v15->add_particle_in(p14); v15->add_particle_in(p17);
  v12->add_particle_out(p18); v15->add_particle_in(p18);
    v15->add_particle_out(p16);
  v16->add_particle_in(p16);
  p11->SetShow(); p12->SetShow(); p13->SetShow();
  p14->SetShow(); p15->SetShow(); p16->SetShow();
  p17->SetShow(); p18->SetShow();

  //Add these events to an event
  VisualEvent* evt = new VisualEvent();
  evt->add_vertex(v11);
  evt->add_vertex(v12);
  evt->add_vertex(v13);
  evt->add_vertex(v14);
  evt->add_vertex(v15);
  evt->add_vertex(v16);
  evt->add_vertex(v17);
  evt->set_signal_process_vertex(v11);
  evt->print();
  evt->SetPDT(pdt);
  evt->Draw();
  
  
  //One loose end
  VisualVertex   * v23 = new VisualVertex(.55,.5);
  VisualVertex   * v24 = new VisualVertex(.75,.5);
  VisualVertex   * v25 = new VisualVertex(.95,.4);
  VisualParticle * p23 = new VisualParticle(fv,23);
  VisualParticle * p24 = new VisualParticle(fv,24);
  VisualParticle * p25 = new VisualParticle(fv,25);
  v23->add_particle_out(p23);
  v24->add_particle_in(p23); v24->add_particle_out(p24);
  v24->add_particle_out(p25);
  v25->add_particle_in(p24);
  p23->SetShow(); p24->SetShow(); p25->SetShow();
  v23->Draw();
  
  //Branching in the beginning
  VisualVertex   * v38 = new VisualVertex(.55,.8);
  VisualVertex   * v39 = new VisualVertex(.75,.7);
  VisualVertex   * v40 = new VisualVertex(.95,.7);
  VisualParticle * p36 = new VisualParticle(fv,36);
  VisualParticle * p37 = new VisualParticle(fv,37);
  VisualParticle * p38 = new VisualParticle(fv,38);
  VisualParticle * p39 = new VisualParticle(fv,39);
  VisualParticle * p40 = new VisualParticle(fv,21);
  VisualParticle * p41 = new VisualParticle(fv,22);
  v38->add_particle_out(p37);
  v39->add_particle_in(p37); v39->add_particle_in(p36); v39->add_particle_out(p38);
  v40->add_particle_in(p38);
  v39->add_particle_in(p39);
  v39->add_particle_in(p40);
  v39->add_particle_in(p41);
  p36->SetShow(); p37->SetShow(); p38->SetShow();
  v39->Draw();
}

void* TestVisualize(){

  LoadLibs();

  using namespace HepMC;

  //Unassoziated
  GenVertex* gvtx = new GenVertex();
  HepMC::VisualVertex* vtx = Visualize(gvtx);
  vtx->Draw();

  //With two visual parents
  VisualVertex* v1 = new VisualVertex(.2,.6);
  v1->suggest_barcode(-1);
  VisualVertex* v2 = new VisualVertex(.2,.3);
  v2->suggest_barcode(-2);
  GenParticle* p1 = new GenParticle(FourVector(0,0,0,0),1);
  GenParticle* p2 = new GenParticle(FourVector(0,0,0,0),2);
  GenParticle* p3 = new GenParticle(FourVector(0,0,0,0),3);
  GenVertex* gv3 = new GenVertex();
  gv3->suggest_barcode(-3);
  v1->add_particle_out(p1);
  v2->add_particle_out(p2);
  gv3->add_particle_in(p1);
  gv3->add_particle_in(p2);
  gv3->add_particle_out(p3);
  vtx->add_particle_in(p3);
  VisualVertex* nv = Visualize(gv3);
  nv->Draw();

  //Another vertex at the same position
  GenParticle* p4 = new GenParticle(FourVector(0,0,0,0),4);
  GenParticle* p5 = new GenParticle(FourVector(0,0,0,0),5);
  GenVertex* gv4 = new GenVertex();
  gv4->suggest_barcode(-4);
  v1->add_particle_out(p4);
  v2->add_particle_out(p5);
  gv4->add_particle_in(p4);
  gv4->add_particle_in(p5);
  VisualVertex* nv14 = Visualize(gv4);
  nv14->SetMarkerColor(2);
  nv14->Draw();
  
  //With three visual children
  VisualVertex* v11 = new VisualVertex(.8,.2);
  VisualVertex* v12 = new VisualVertex(.8,.4);
  VisualVertex* v13 = new VisualVertex(.8,.6);
  GenParticle* p11 = new GenParticle(FourVector(0,0,0,0),11);
  GenParticle* p12 = new GenParticle(FourVector(0,0,0,0),12);
  GenParticle* p13 = new GenParticle(FourVector(0,0,0,0),13);
  GenVertex* gv10 = new GenVertex();
  v11->add_particle_in(p11);
  v12->add_particle_in(p12);
  v13->add_particle_in(p13);
  gv10->add_particle_out(p11);
  gv10->add_particle_out(p12);
  gv10->add_particle_out(p13);
  VisualVertex* nv2 = Visualize(gv10);
  nv2->Draw();

  //One visual parent
  GenParticle* p21 = new GenParticle(FourVector(0,0,0,0),21);
  GenVertex* gv20 =new GenVertex();
  v11->add_particle_out(p21);
  gv20->add_particle_in(p21);
  VisualVertex* nv3 = Visualize(gv20);
  nv3->Draw();
  //One visual child and invisble particle
  GenParticle* p22 = new GenParticle(FourVector(0,0,0,0),22);
  GenVertex* gv30 =new GenVertex();
  gv30->add_particle_out(p22);
  nv2->add_particle_in(p22);
  VisualVertex* nv4 = Visualize(gv30);
  nv4->Draw();

  //A non-visual particle
  GenParticle* gp = new GenParticle(FourVector(),34);
  nv3->add_particle_out(gp);
  nv4->add_particle_in(gp);

  //With non visual children
  VisualVertex* v101 = new VisualVertex(.7,.8);
  v1->suggest_barcode(-1);
  GenVertex* v102 = new GenVertex();
  v2->suggest_barcode(-2);
  GenParticle* p101 = new GenParticle(FourVector(0,0,0,0),1);
  GenParticle* p102 = new GenParticle(FourVector(0,0,0,0),2);
  v101->add_particle_out(p101);
  v102->add_particle_in(p101);
  v102->add_particle_out(p102);
  v101->Draw();



  return nv14;
}

void* TestNewDir(){

  LoadLibs();

  using namespace HepMC;

  VisualVertex* v1 = new VisualVertex(.5,.5);
  VisualParticle *p1 = new VisualParticle(FourVector(1,2,3,4),1);
  VisualParticle *p2 = new VisualParticle(FourVector(1,2,3,4),2);
  VisualParticle *p3 = new VisualParticle(FourVector(1,2,3,4),3);
  VisualParticle *p4 = new VisualParticle(FourVector(1,2,3,4),4);
  VisualParticle *p5 = new VisualParticle(FourVector(1,2,3,4),5);
  v1->add_particle_in(p1);
  v1->add_particle_in(p2);
  v1->add_particle_out(p3);
  v1->add_particle_out(p4);
  v1->add_particle_out(p5);

  v1->Draw();
  
}

Bool_t TestFindVertex(){

  LoadLibs();

  using namespace HepMC;

  //This is our wishlist
//  Int_t inl[] = {1,2}; std::vector<Int_t> vin(inl,inl+2);
    std::vector<Int_t> vin;
    vin.push_back(2);
    vin.push_back(1);
    
//  Int_t outl[] = {3,5}; std::vector<Int_t> vout(outl,outl+2);
    std::vector<Int_t> vout;
    vout.push_back(3);
    vout.push_back(3);

  FourVector* fv = new FourVector();

  //Vertex that has others
  GenVertex* v1 = new GenVertex(); v1->suggest_barcode(-1);
  v1->add_particle_in( new GenParticle(*fv,3));
  v1->add_particle_in( new GenParticle(*fv,2));
  v1->add_particle_out( new GenParticle(*fv,3));
  v1->add_particle_out( new GenParticle(*fv,3));
  v1->add_particle_out( new GenParticle(*fv,5));

  //Vertex that has no inputs
  GenVertex* v2 = new GenVertex(); v2->suggest_barcode(-2);
  v2->add_particle_out( new GenParticle(*fv,3));
  v2->add_particle_out( new GenParticle(*fv,4));
  v2->add_particle_out( new GenParticle(*fv,5));
  
  //Vertex that has no outputs
  GenVertex* v3 = new GenVertex(); v3->suggest_barcode(-3);
  v3->add_particle_in( new GenParticle(*fv,3));
  v3->add_particle_in( new GenParticle(*fv,2));
  

  //Vertex that has all of them
  GenVertex* v4 = new GenVertex(); v4->suggest_barcode(-4);
  v4->add_particle_in( new GenParticle(*fv,1));
  v4->add_particle_in( new GenParticle(*fv,2));
  v4->add_particle_out( new GenParticle(*fv,3));
  v4->add_particle_out( new GenParticle(*fv,4));
  v4->add_particle_out( new GenParticle(*fv,3));

  //Add all of these to the event
  VisualEvent* newevt = new VisualEvent();
  newevt->add_vertex(v1);
  newevt->add_vertex(v2);
  newevt->add_vertex(v3);
  newevt->add_vertex(v4);

  cout <<"Found:" << newevt->FindSignalProcess(vin,vout) << endl;
  newevt->Draw();
  return newevt;

}
  
void TestSiblings(){

  LoadLibs();
  
  using namespace HepMC;
  //Draw a new BrowserFrame
  //VisualBrowserFrame * vbrowser = new VisualBrowserFrame();
  TCanvas * c1 = new TCanvas();
  
  //Get a pdt
  IO_PDG_ParticleDataTable iopdt("PDG_table_2006.mc");
  ParticleDataTable* pdt = iopdt.read_particle_data_table();
  pdt->make_antiparticles_from_particles();
  pdt->print();

  HepMC::FourVector fv(0,0,0,0);
 
  //Three particles inbetween the same vertex
  VisualVertex   * v0 = new VisualVertex(.25,.5);
  VisualVertex   * v1 = new VisualVertex(.75,.5);
  VisualVertex   * v2 = new VisualVertex(.5,.75);
  VisualParticle * p1 = new VisualParticle(fv,1);
  VisualParticle * p2 = new VisualParticle(fv,21);
  VisualParticle * p3 = new VisualParticle(fv,22);
  VisualParticle * p4 = new VisualParticle(fv,21);
  VisualParticle * p5 = new VisualParticle(fv,5);
  VisualParticle * p6 = new VisualParticle(fv,6);
  VisualParticle * p7 = new VisualParticle(fv,7);
  v0->add_particle_out(p1);
  v0->add_particle_out(p2);
  v0->add_particle_out(p3);
  v0->add_particle_out(p4);
  v0->add_particle_out(p5);
  v0->add_particle_out(p6);
  v0->add_particle_out(p7);
  v1->add_particle_in(p1);
  v1->add_particle_in(p2);
  v2->add_particle_in(p3);
  v2->add_particle_in(p4);
  v2->add_particle_in(p5);
  v2->add_particle_in(p6);
  v2->add_particle_in(p7);
  p1->SetShow(); p2->SetShow(); p3->SetShow();
  p4->SetShow(); p5->SetShow(); p6->SetShow();
  p7->SetShow(); 
  v1->Draw();

}
